#! /bin/sh -e

srcdir=$1

## Check for pthread types

if test -r /usr/include/bits/pthreadtypes.h
then
(
$srcdir/mkinstalldirs include/bits
cp /usr/include/bits/pthreadtypes.h include/bits/pthreadtypes.h
patch include/bits/pthreadtypes.h <<EOF
--- /usr/include/bits/pthreadtypes.h	Fri Apr  6 21:29:07 2001
+++ pthreadtypes.h	Wed Jul 11 11:09:44 2001
@@ -19,6 +19,8 @@
 #ifndef _BITS_PTHREADTYPES_H
 #define _BITS_PTHREADTYPES_H	1
 
+#if !defined(IN_CK) && !defined(_CARBONKERNEL_)
+
 #define __need_schedparam
 #include <bits/sched.h>
 
@@ -138,5 +140,55 @@
 
 /* Thread identifiers */
 typedef unsigned long int pthread_t;
+
+#else /* IN_CK || _CARBONKERNEL_ */
+
+struct rtl_cleanup_struct {
+
+    void (*routine)(void *arg);
+    void *arg;
+    struct rtl_cleanup_struct *next;
+};
+
+struct rtl_thread_struct {
+
+    unsigned long handle;
+    struct rtl_cleanup_struct *cleanup;
+};
+
+typedef struct rtl_thread_struct RTL_THREAD_STRUCT;
+
+typedef struct rtl_thread_struct *pthread_t;
+
+struct rtl_sched_param {
+
+    int sched_priority;
+};
+
+#define sched_param rtl_sched_param
+
+enum rtl_task_states {
+
+    RTL_THREAD_READY =1,
+    RTL_THREAD_DELAYED =2,
+    RTL_THREAD_DORMANT =4,
+    RTL_THREAD_SUSPENDED =8,
+    RTL_THREAD_ACTIVE =16,
+    RTL_THREAD_ZOMBIE =32,
+    RTL_THREAD_WAIT_NEEDED =64
+};
+
+typedef struct STRUCT_PTHREAD_ATTR {
+
+    size_t stack_size;
+    struct rtl_sched_param sched_param;
+    int cpu;			/* Ck: unused */
+    int use_fp;			/* Ck: unused */
+    int detachstate;
+    enum rtl_task_states initial_state;
+
+} pthread_attr_t;
+
+#endif /* !IN_CK && !_CARBONKERNEL_ */
 
 #endif	/* bits/pthreadtypes.h */
EOF
$srcdir/mkinstalldirs include/rtl/bits
cp include/bits/pthreadtypes.h include/rtl/bits/pthreadtypes.h
) > /dev/null

echo rtl/bits/pthreadtypes.h
fi

## Check for clockid_t

grep -q '^typedef __clockid_t clockid_t' /usr/include/time.h
if test $? = 0
then
(
$srcdir/mkinstalldirs include
cp /usr/include/time.h include/time.h
patch include/time.h <<EOF
--- /usr/include/time.h	Fri Apr  6 21:29:04 2001
+++ time.h	Wed Jul 11 11:19:02 2001
@@ -79,7 +79,11 @@
 # include <bits/types.h>
 
 /* Clock ID used in clock and timer functions.  */
+#if !defined(IN_CK) && !defined(_CARBONKERNEL_)
 typedef __clockid_t clockid_t;
+#else
+typedef struct rtl_clock *clockid_t;
+#endif /* !IN_CK && !_CARBONKERNEL_ */
 
 #endif /* clockid_t not defined and <time.h> or need clockid_t.  */
 #undef	__clockid_time_t
EOF
$srcdir/mkinstalldirs include/rtl
cp include/time.h include/rtl/time.h
) > /dev/null

echo rtl/time.h
fi

exit 0
