/*
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: POSIX time header replacement for the RTLinux model
 * on top of CarbonKernel.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtl_posix_time_h
#define _rtl_posix_time_h

#include <rtl/rtl_time.h>

#ifdef CLOCK_REALTIME
#undef CLOCK_REALTIME
#endif
#define CLOCK_REALTIME  ck_clock_getrealtime()
#ifdef CLOCK_UST
#undef CLOCK_UST
#endif
#define CLOCK_UST       ck_clock_getust()

#ifdef __cplusplus
extern "C" {
#endif

clockid_t ck_clock_getust();

clockid_t ck_clock_getrealtime();

#define clock_gettime ck_clock_gettime
int ck_clock_gettime(clockid_t clock,
		     struct timespec *tp);

#define clock_settime ck_clock_settime
int ck_clock_settime(clockid_t clock,
		     const struct timespec *tp);

#define clock_getres ck_clock_getres
int ck_clock_getres(clockid_t clock,
		    struct timespec *res);

#define clock_gethrtime ck_clock_gethrtime
hrtime_t ck_clock_gethrtime(clockid_t clock);

#define time(tloc) ck_time(tloc)
time_t ck_time(time_t *tloc);

#ifdef __cplusplus
};
#endif

#endif /* !_rtl_posix_time_h */
