/*
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Simplified placeholder for the original rtl_core.h file.
 * Based on rtl_core.h from the standard RTLinux distribution
 * written by Cort Dougan <cort@fsmlabs.com> and Victor Yodaiken
 * <yodaiken@fsmlabs.com>.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtl_core_h
#define _rtl_core_h

#include <ck/stypes.h>
#include <rtl/rtl_printf.h>

struct pt_regs;

#ifdef __cplusplus
extern "C" {
#endif

typedef int (*rtl_irq_handler_t)(unsigned, struct pt_regs *);

typedef void (*rtl_soft_irq_handler_t)(unsigned, void *, struct pt_regs *);

void rtl_hard_enable_irq(unsigned irq);

void rtl_hard_disable_irq(unsigned irq);

#define rtl_request_irq rtl_request_global_irq
int rtl_request_global_irq(unsigned irq,
			   rtl_irq_handler_t handler);

#define rtl_free_irq rtl_free_global_irq
int rtl_free_global_irq(unsigned irq);

int rtl_get_soft_irq(rtl_soft_irq_handler_t handler,
		     const char *devname);

void rtl_free_soft_irq(unsigned irq);

void rtl_global_pend_irq(unsigned irq);

void rtl_schedule(void);

/* Ck: currently UP targets only */
#define rtl_irq_set_affinity(irq,mask) ((void)-1)
#define rtl_cpu_exists(cpu) (cpu == 0)
#define rtl_getcpuid()      (0)

void conpr(const char *s);

void conprn(unsigned hexnum);

#ifdef __cplusplus
};
#endif

#endif /* !_rtl_core_h */
