/*
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Interface to the standard semaphore object.
 * Based on rtl_sema.h from the standard RTLinux distribution
 * written by Michael Barabanov <baraban@fsmlabs.com>.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtl_sema_h
#define _rtl_sema_h

typedef struct rtl_sem_struct {

    ckhandle_t handle;

} sem_t;

#ifdef __cplusplus
extern "C" {
#endif

#include <rtl/rtl_sched.h>

int sem_init(sem_t *sem,
	     int pshared,
	     unsigned int init_val);

int sem_destroy(sem_t *sem);

int sem_getvalue(sem_t *sem,
		 int *sval);

int sem_wait(sem_t *sem);

int sem_trywait(sem_t *sem);

int sem_post(sem_t *sem);

int sem_timedwait(sem_t *sem,
		  const struct timespec *abs_timeout);

#ifdef __cplusplus
};
#endif

#endif /* !_rtl_sema_h */
