/*
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Interface to the interrupt management routines.
 * Based on rtl_sync.h from the standard RTLinux distribution
 * written by Cort Dougan <cort@fsmlabs.com> and
 * Victor Yodaiken <yodaiken@fsmlabs.com>.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtl_sync_h
#define _rtl_sync_h

typedef unsigned long rtl_irqstate_t;

#ifdef __cplusplus
extern "C" {
#endif

#define rtl_spin_lock(x)	        (void)(x)
#define rtl_spin_trylock(x)	        (1)
#define rtl_spin_unlock(x)	        do {} while(0)
#define rtl_spin_lock_irqsave(x,s)      rtl_critical(s)
#define rtl_spin_unlock_irqrestore(x,s) rtl_end_critical(s)

#define	rtl_no_interrupts(s)       ck_rtl_no_interrupts(&(s))
#define	rtl_restore_interrupts(s)  ck_rtl_restore_interrupts(&(s))
#define rtl_critical(s)            ck_rtl_no_interrupts(&(s))
#define rtl_end_critical(s)        ck_rtl_restore_interrupts(&(s))
#define rtl_stop_interrupts()      ck_rtl_no_interrupts(0)
#define rtl_allow_interrupts()     ck_rtl_restore_interrupts(0)

void ck_rtl_no_interrupts(rtl_irqstate_t *s);

void ck_rtl_restore_interrupts(rtl_irqstate_t *s);

#ifdef __cplusplus
};
#endif

#endif /* !_rtl_sync_h */
