/* -*- C++ -*-
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Interface to the RTLinux node configuration classes.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtlConfig_h
#define _rtlConfig_h

#if defined(__GNUG__) && !defined(__OBSCAN__)
#pragma interface
#endif // __GNUG__ && !__OBSCAN__

#include "CkConfig.h"

#ifdef IMPLEMENTING_SO
#undef IMPLEMENTING_SO
#endif // IMPLEMENTING_SO
#define IMPLEMENTING_SO IMPLEMENT_RTL
#include "sodecl.h"

class rtlConfig : public CfClass {
// ^obstick^ (do not remove this comment)
protected:
	virtual const char *DBgetActiveOLI() const;
	virtual const char *DBgetPassiveOLI() const;
	virtual long DBactivate(DBMemory *chunk);
	virtual long DBdeactivate(DBMemory *chunk);
	virtual long DBimport(FILE *fp);
	virtual long DBexport(FILE *fp);
	virtual void DBsizeof(size_t& activeSize, size_t& passiveSize) const;
public:
	static const char *className;
	virtual DBClassName DBgetClassName() const;
	virtual int DBprobeClass(DBClassName className) const;
	operator const DBObject *() const;
// $obstick$ (do not remove this comment)

protected:

    rtlConfig(rtlConfig& src);

    rtlConfig(DBapl *apl);

public:

    rtlConfig(const char *instanceName,
	      CfContext *context);

    virtual void instantiate(CfContext *context);
};

#endif  // !_rtlConfig_h
