/* -*- C++ -*-
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Interface to the RTLinux interrupt model.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#ifndef _rtlInterrupt_h
#define _rtlInterrupt_h

#if defined(__GNUG__) && !defined(__OBSCAN__)
#pragma interface
#endif // __GNUG__ && !__OBSCAN__

#include "CkInterrupt.h"
#include "rtl/rtl_core.h"

#ifdef IMPLEMENTING_SO
#undef IMPLEMENTING_SO
#endif // IMPLEMENTING_SO
#define IMPLEMENTING_SO IMPLEMENT_RTL
#include "sodecl.h"

#define RTL_IRQ_MAX 32

class rtlNode;

class rtlInterrupt : public CkInterrupt {

protected:

    rtl_irq_handler_t hardHandler;

    rtl_soft_irq_handler_t softHandler;

public:

    rtlInterrupt(unsigned irq,
		 ckisr_t trampoline,
		 rtl_irq_handler_t hardHandler,
		 const char *name,
		 void *cookie,
		 rtlNode *node);

    rtl_irq_handler_t getHardHandler() const {
	return hardHandler;
    }

    void setHardHandler(rtl_irq_handler_t _handler) {
    	hardHandler = _handler;
    }

    rtl_soft_irq_handler_t getSoftHandler() const {
	return softHandler;
    }

    void setSoftHandler(rtl_soft_irq_handler_t _handler) {
    	softHandler = _handler;
    }
};

#endif // !_rtlInterrupt_h
