/*
 * This file is part of the CarbonKernel Simulation System.
 * Copyright (C) 1997-2000 Realiant Systems.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The original code is CarbonKernel - Real-time Operating System Simulator,
 * released April 15, 2000. The initial developer of the original code is
 * Realiant Systems (http://www.realiant.com).
 *
 * Description: Trivial monitor application used to communicate with
 * (simulated) RTLinux apps using FIFOs.
 *
 * Author(s): rpm
 *
 * Contributor(s):
 *
 */

#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

main (int argc, char *argv[])

{
    int fdi, fdo;
    char c;

    if (argc < 3)
	return 1;

    fdi = open(argv[2],O_RDONLY);
    fdo = open(argv[1],O_WRONLY);

    if (fdi < 0 || fdo < 0)
	return 2;

    switch (*argv[3])
	{
	case 'a':

	    write(fdo,"hello",6); /* send \0 too */
	    read(fdi,&c,1);
	    write(fdo,"world",6);
	    read(fdi,&c,1);
	    break;
	}

    close(fdi);
    close(fdo);

    return 0;
}
